<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="标题" prop="title">
        <el-input
            v-model="queryParams.title"
            placeholder="请输入标题"
            clearable
            @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
            type="primary"
            plain
            icon="Plus"
            @click="handleAdd"
            v-hasPermi="['basicData:release:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="success"
            plain
            icon="Edit"
            :disabled="single"
            @click="handleUpdate"
            v-hasPermi="['basicData:release:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="danger"
            plain
            icon="Delete"
            :disabled="multiple"
            @click="handleDelete"
            v-hasPermi="['basicData:release:remove']"
        >删除</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="releaseList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
<!--      <el-table-column label="主键" align="center" prop="id" />-->
      <el-table-column label="标题" align="center" prop="title" />
      <el-table-column label="专栏" align="center" prop="specialColumn" >
        <template #default="scope">
          {{dickMapObj[scope.row.specialColumn]}}
        </template>
      </el-table-column>
      <el-table-column label="发布时间" align="center" prop="date" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.date, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="内容" align="center" prop="content" >
        <template #default="scope">
          {{scope.row.content}}
        </template>
      </el-table-column>
      <el-table-column label="附件" align="center" width="220">
        <template #default="scope">
          <div v-html="computedImg(scope.row)"></div>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button
              type="text"
              icon="Edit"
              @click="handleUpdate(scope.row)"
              v-hasPermi="['basicData:release:edit']"
          >修改</el-button>
          <el-button
              type="text"
              icon="Delete"
              @click="handleDelete(scope.row)"
              v-hasPermi="['basicData:release:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
        v-show="total>0"
        :total="total"
        v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize"
        @pagination="getList"
    />

    <!-- 添加或修改新闻发布对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="releaseRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="标题" prop="title">
          <el-input v-model="form.title" placeholder="请输入标题" />
        </el-form-item>
        <el-form-item label="专栏" prop="specialColumn">
<!--          <el-input v-model="form.specialColumn" placeholder="请输入专栏" />-->
          <el-select v-model="form.specialColumn" placeholder="请输入专栏">
            <el-option
                v-for="dict in dickArr"
                :key="dict.dictValue"
                :label="dict.dictLabel"
                :value="dict.dictValue"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="发布时间" prop="date">
          <el-date-picker clearable
                          v-model="form.date"
                          type="date"
                          value-format="YYYY-MM-DD"
                          placeholder="请选择发布时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="内容">
          <el-input v-model="form.content" :min-height="192" type="textarea"/>
          <el-upload
              ref="uploadRef"
              v-model:file-list="fileList"
              :action="upload.url"
              :on-remove="handleRemove"
              :multiple="true"
              accept=".doc, .docx, .png, .jpg, .pdf"
              :on-change = "handleChange"
              :headers="upload.headers"
              :on-success="handleFileSuccess"
              :before-upload="beforeUpload"
              :data="{moduleName:'新闻模块'}"
          >
            <el-button type="primary">上传附件</el-button>
            <template #tip>
              <div class="el-upload__tip">
                只能上传doc docx png jpg pdf文件
              </div>
            </template>
          </el-upload>
        </el-form-item>

      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Release">
import {listRelease, getRelease, delRelease, addRelease, updateRelease, getDict} from "@/api/basicData/release";
import {likeQueryMethod} from "../../../utils/likeQueryMethod";
import {computed, reactive, ref} from "vue";
import {getToken} from "@/utils/auth";
import {delImgById} from "@/api/basicData/complain";
import {ElMessage} from "element-plus";

const { proxy } = getCurrentInstance();

const releaseList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const dickArr = ref([]);
let dickMapObj = ref({});
const fileList = ref([]);
const baseUrl = import.meta.env.VITE_APP_BASE_API;
const beforeUpdateLimit = ref(0);
const computedImg= (r)=>{
  let resQueue = [];
  let docImg = '<img src="/docPreview.jpg" style="width: 20px;" />'
  let pdfImg = '<img src="/pdfPreview.jpg" style="width: 20px;" />'
  let Img = '<img src="/favicon.png" style="width: 20px;" />'
  let isImg = false;
  r.files.map(i=>i.fileUrl.substring(i.fileUrl.lastIndexOf('.'))).map(i=>{
    if(i=='.doc'||i=='.docx'){
      resQueue.push(docImg);
    }else if (i=='.pdf'){
      resQueue.push(pdfImg)
    }else if (i=='.png'||i=='.jpg'){
      isImg = true;
      resQueue = [];
      console.log(r.files[0].fileUrl);
      // resQueue.push(Img)
      const url = baseUrl + r.files[0].fileUrl;
      // return `<img src="${url}" />`
    }
  })
  if(isImg){
    isImg = false;
    return `<img src="${baseUrl+ r.files[0].fileUrl}" style="width: 200px;" />`
  }
  return resQueue.join('');
}

const upload = reactive({
  // 是否显示弹出层（用户导入）
  open: false,
  // 弹出层标题（用户导入）
  title: '',
  // 是否禁用上传
  isUploading: false,
  // 设置上传的请求头部
  headers: {Authorization: getToken()},
  // 上传的地址
  url: import.meta.env.VITE_APP_BASE_API + '/commonFile/uploadFile',
})
const handleRemove = async (uploadFile, uploadFiles) => {
  let id;
  let res;
  if(!uploadFile.id){
    form.value.files.forEach(item=>{
      if(item.fileOriginalName == uploadFile.name) {
        id = item.id;
        delImgById(id).then(r => {
          if (r.code == 200) {
            proxy.$modal.msgSuccess("删除成功");
          }
        });
      }
    })
    return;
  }
  id = uploadFile.id
  res = await delImgById(id);
  if(res.code == 200){
    proxy.$modal.msgSuccess("删除成功");
  }
}
// const handleChange = (file,filelist)=>{
//   console.log(file,888);
// }
const handleFileSuccess = (e,v)=>{
  beforeUpdateLimit.value = beforeUpdateLimit.value-1
  form.value.files.push(e.data)
  if(e.code == 200){
    ElMessage({
      type:"success",
      message:e.msg
    })
  }
}
const beforeUpload = ()=>{
  beforeUpdateLimit.value = beforeUpdateLimit.value +1;
}


const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    title: '',
    specialColumn: null,
    date: null,
    content: null,
    files:[]
  },
  rules: {
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询新闻发布列表 */
function getList() {
  loading.value = true;
  let toServerObj = likeQueryMethod('title', queryParams.value.title, queryParams.value.pageNum, queryParams.value.pageSize);
  listRelease(toServerObj).then(response => {
    releaseList.value = response.records;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    title: '',
    specialColumn: null,
    date: null,
    content: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    files:[]
  };
  proxy.resetForm("releaseRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
  fileList.value = [];
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加新闻发布";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const id = row.id || ids.value
  getRelease(id).then(response => {
    form.value = response.data.data;
    fileList.value = response.data.data.files.map(item=>{
      return{
        name:item.fileOriginalName,
        url: import.meta.env.VITE_APP_BASE_API + item.fileUrl,
        id:item.id
      }
    })
    open.value = true;
    title.value = "修改新闻发布";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["releaseRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        console.log(form.value);
        updateRelease(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
          fileList.value = [];
        });
      } else {
        addRelease(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
          fileList.value = [];
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const ids2 = row.id || ids.value;
  console.log(ids2);
  proxy.$modal.confirm('是否确认删除新闻发布编号为"' + ids2 + '"的数据项？').then(function() {
    return delRelease(ids2);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('basicData/release/export', {
    ...queryParams.value
  }, `release_${new Date().getTime()}.xlsx`)
}
const init = async ()=>{
  let res = await getDict('news_type');
  dickArr.value = res.data;
  dickMapObj.value = dickArr.value.reduce((pre,cur)=>{
    pre[cur.dictValue] = cur.dictLabel;
    return pre;
  },{})
}
init();
getList();
</script>

